#include "sndawk.lx.h"
#include <stdio.h>
#include "red.h"

%%
@	LWHILE	VEXPLIST
/*
 * VEXPLIST devient VWHILE et LWHILE disparait.
 */
			STYPE(last,VWHILE)
			LIEN(first -> frereg, last)
			free(first);
			R
			
@	VWHILE	VSTAT
/*
 * Un nouveau VSTAT est cree. Il recoit comme fils le VWHILE. Le VSTAT a droite
 * de VWHILE devient le frered du fils de VWHILE (frere de la condition).
 */
			SALLOC
			STYPE(symb,VSTAT)
			LIEN(first -> frereg, symb)
			LIEN(symb, last -> frered)
			symb -> fils = first;
			LIEN(first -> fils, last)
			first -> frereg = first -> frered = NULL;
			last -> frered = NULL;
			R
			
@	LIF	VEXPLIST
/*
 * VEXPLIST devient VIF et LIF disparait.
 */
			STYPE(last,VIF)
			LIEN(first -> frereg, last)
			free(first);
			R
			
@	VIF	VSTAT
/*
 * Un nouveau VSTAT est cree. Il recoit comme fils le VIF. Le VSTAT a droite
 * de VIF devient le frered du fils de VIF (frere de la condition).
 */
			if(last -> frered ->symbtype == LPTVIRG){
				symb = last -> frered;
				LIEN(last, symb -> frered)
				free(symb);
			}
			if(last -> frered ->symbtype == LELSE){
				STYPE(last, VIFELSE)
				R
			}
			SALLOC
			STYPE(symb,VSTAT)
			LIEN(first -> frereg, symb)
			LIEN(symb, last -> frered)
			symb -> fils = first;
			LIEN(first -> fils, last)
			first -> frereg = first -> frered = NULL;
			last -> frered = NULL;
			R
			
@	VIF	VIFELSE	LELSE	VSTAT
			STYPE(last -> frereg, VSTAT)
			STYPE(first -> frered, VSTAT)
			LIEN(first -> frereg, last -> frereg)
			LIEN(last -> frereg, last -> frered)
			last -> frereg -> fils = first;
			LIEN(first -> fils, first -> frered)
			LIEN(first -> frered, last)
			first -> frereg = first -> frered = NULL;
			last -> frered = NULL;
			R
@	VF1	LPTVIRG
			STYPE(first, VFOR1)
			LIEN(first, last -> frered)
			free(last);
			R
 
@	VF2	LPTVIRG
			STYPE(first, VFOR2)
			LIEN(first, last -> frered)
			free(last);
			R
 
@	VF3	LPARFERM
			STYPE(first, VFOR3)
			LIEN(first, last -> frered)
			free(last);
			R
 
@	LPARFERM
			STYPE(first,VFOR3)
			R

@	LPAROUVR	VFOR1	VFOR2	VFOR3
			STYPE(first,VFOR)
			LIEN(last -> frereg -> fils, last -> fils)
			LIEN(first -> frered -> fils, last -> frereg -> fils)
			first -> fils = first -> frered -> fils;
			LIEN(first, last -> frered)
			free(last -> frereg -> frereg);
			free(last -> frereg);
			free(last);
			R

@	LFOR	VFOR	VSTAT
			STYPE(first,VSTAT)
			first -> fils = first -> frered;
			LIEN(first, last -> frered)
			LIEN(first -> fils -> fils -> frered -> frered,last)
			first -> fils -> frereg = first -> fils -> frered = 
			last -> frered = NULL;
			R

@	LPRINT	VEXPLIST
/*
 * VEXPLIST devient VSTAT. Il recoit comme fils le LPRINT (qui erite comme
 * fils l'ancien fils de VEXPLIST)
 */
			STYPE(last,VPRINT)
			LIEN(first -> frereg, last)
			FILS(first, last)
			R
			
@	LPRINTF	LSTRING VEXPLIST
@	LPRINTERR	LSTRING VEXPLIST
/*
 * VEXPLIST devient VPRINT. LSTRING devient d'abord le fils de LPRINTF puis
 * il prend comme frere droit le fils de l'ancien VEXPLIST, puis le tout
 * (LPRINTF avec comme liste de fils LSTRING et son nouveau frere )
 * devient le fils du nouveau VSTAT.
 */
			STYPE(last,VPRINT)
			LIEN(first -> frereg, last)
			FILS(first -> frered, first)
			LIEN(first -> fils, last -> fils)
			last -> fils = first;
			first -> frereg = first -> frered = NULL;
			R

@	LPRINTF	LSTRING2
@	LPRINTERR	LSTRING2
/*
 * 
 * 
 */
			SALLOC
			STYPE(symb,VPRINT)
			LIEN(first -> frereg, symb)
			LIEN(symb, last -> frered)
			FILS(first, symb)
			FILS(last, first)
			R

@	VPRINT
			STYPE(first,VSTAT2)
			R

@	VPRINT	LWRITE	LFILE
@	VPRINT	LAPPEND LFILE
@	VPRINT	LPIPE	LCOM
			if (first -> fils -> symbtype != LPRINTERR){
				STYPE(first,VSTAT2)
				LIEN(first, last -> frered)
				free(last -> frereg);
				LIEN(first -> fils, last)
				last -> frered = NULL;
				R
			}
			else return(NULL);
			
@	VLVAL	LASGNOP	VEXP
/*
 * LVAR recoit comme frere droit le fils
 * de VEXP et devient provisoirement le fils de VEXP.
 * LASGNOP devient le fils de VEXP (en heritant comme fils la liste LVAR
 * fils de VEXP ).
 */
			LIEN(first -> fils, last -> fils)
			last->fils = first -> fils;
			FILS(last -> frereg, last)
			LIEN(first -> frereg, last)
			free(first);
			R

@	VLVAL	LREAD	LFILE
			SALLOC
			STYPE(symb,VEXP)
			LIEN(first -> frereg, symb)
			LIEN(symb, last -> frered)
			symb -> fils = first -> frered;
			symb -> fils -> frered = symb -> fils -> frereg = NULL;
			symb -> fils -> fils = first;
			LIEN(first,last)
			first -> frereg = last -> frered = NULL;
			R

@	LCOM	LPIPE	VLVAL
			SALLOC
			STYPE(symb, VEXP)
			LIEN(first -> frereg, symb)
			LIEN(symb, last -> frered)
			STYPE(first -> frered,LREAD)
			symb -> fils = first -> frered;
			symb -> fils -> frered = symb -> fils -> frereg = NULL;
			LIEN(last,first)
			first -> frered = last -> frereg = NULL;
			symb -> fils -> fils = last;
			R
			

@	VEXP
			STYPE(first,VEXPLIST)
			R

@	VLOGEXP	LPTINTER	VALT
/*
 * VLOGEXP devient VEXPALT. LPTINTER devient son fils en heritant comme fils
 * la liste fils de l'ancien VEXP fils de VALT. VALT disparait.
 */
			STYPE(first,VEXPALT)
			LIEN(first->fils,last->fils)
			LIEN(first,last->frered)
			FILS(last->frereg,first);
			free(last);
			R

@	VLOGEXP	LDEUXPTS	VLOGEXP
/*
 * Le premier VEXP devient VALT. Son fils recoit comme frere droit le
 * fils du deuxime VEXP. LDEUXPTS et VEXP disparaissent.
 */
			STYPE(first,VALT)
			LIEN(first->fils,last->fils)
			LIEN(first,last->frered)
			free(last->frereg);
			free(last);
			R
			
