/* %M%	%I%	(CARL)	%G%	%U% */
#include <carl/libsf.h>
#include <stdio.h>

inifree(dev, alloc, savalloc)
	char *dev, *alloc, *savalloc;
{	/* make one up */
	FILE *fp, *fopen();
	struct dskblk *makenew(), *head;
	char *getsfile();
	struct sfstab *sfs, *dirinfo();
	register long maxcyls;

	sfs = dirinfo(dev);
	if (sfs == NULL) {
	    fprintf(stderr, "inifree: dirinfo failed\n");
	    return(-1);
	}
	maxcyls = sfs->devlen;
	if ((head = makenew(maxcyls)) == NULL) {
	    fprintf(stderr, "inifree: error making new free list\n");
	    return(-1);
	}
	/* make one first so wlist will be happy */
	if ((fp = fopen(alloc, "w")) == NULL) {
		fprintf(stderr, "inifree: error opening %s\n", alloc);
		return(-1);
	}
	if (fclose(fp) < 0) {
		perror("fclose");
		return(-1);
	}
	if ((fp = fopen(savalloc, "w")) == NULL) {
		fprintf(stderr, "inifree: error opening %s\n", savalloc);
		return(-1);
	}
	if (fclose(fp) < 0) {
		perror("fclose");
		return(-1);
	}
	if (wlist(head,alloc, 1))
		return(-1);
	return(0);
}
